extern void GLCD_SetPixel(unsigned char x, unsigned char y, unsigned char color);

const unsigned char color = 1;

void GLCD_Rectangle(unsigned char x, unsigned char y, unsigned char b, unsigned char a)
{
  unsigned char j; // zmienna pomocnicza
  // rysowanie linii pionowych (boki)
  for (j = 0; j < a; j++) {
		GLCD_SetPixel(x, y + j, color);
		GLCD_SetPixel(x + b - 1, y + j, color);
	}
  // rysowanie linii poziomych (podstawy)
  for (j = 0; j < b; j++)	{
		GLCD_SetPixel(x + j, y, color);
		GLCD_SetPixel(x + j, y + a - 1, color);
	}
}
//

void GLCD_Circle(unsigned char cx, unsigned char cy ,unsigned char radius)
{
int x, y, xchange, ychange, radiusError;
x = radius;
y = 0;
xchange = 1 - 2 * radius;
ychange = 1;
radiusError = 0;
while(x >= y)
  {
  GLCD_SetPixel(cx+x, cy+y, color); 
  GLCD_SetPixel(cx-x, cy+y, color); 
  GLCD_SetPixel(cx-x, cy-y, color);
  GLCD_SetPixel(cx+x, cy-y, color); 
  GLCD_SetPixel(cx+y, cy+x, color); 
  GLCD_SetPixel(cx-y, cy+x, color); 
  GLCD_SetPixel(cx-y, cy-x, color); 
  GLCD_SetPixel(cx+y, cy-x, color); 
  y++;
  radiusError += ychange;
  ychange += 2;
  if ( 2*radiusError + xchange > 0 )
    {
    x--;
	radiusError += xchange;
	xchange += 2;
	}
  }
}
//

void GLCD_Line(unsigned int X1,unsigned int Y1,unsigned int X2,unsigned int Y2)
{
int CurrentX, CurrentY, Xinc, Yinc, 
    Dx, Dy, TwoDx, TwoDy, 
	TwoDxAccumulatedError, TwoDyAccumulatedError;

Dx = (X2-X1); // obliczenie skï¿½adowej poziomej
Dy = (Y2-Y1); // obliczenie skï¿½adowej pionowej

TwoDx = Dx + Dx; // podwojona skï¿½adowa pozioma
TwoDy = Dy + Dy; // podwojona skï¿½adowa pionowa

CurrentX = X1; // zaczynamy od X1
CurrentY = Y1; // oraz Y1

Xinc = 1; // ustalamy krok zwiï¿½kszania pozycji w poziomie 
Yinc = 1; // ustalamy krok zwiï¿½kszania pozycji w pionie

if(Dx < 0) // jesli skï¿½adowa pozioma jest ujemna 
  {
  Xinc = -1; // to bï¿½dziemy siï¿½ "cofaï¿½" (krok ujemny)
  Dx = -Dx;  // zmieniamy znak skï¿½adowej na dodatni
  TwoDx = -TwoDx; // jak rï¿½wnieï¿½ podwojonej skï¿½adowej
  }

if (Dy < 0) // jeï¿½li skï¿½adowa pionowa jest ujemna
  {
  Yinc = -1; // to bï¿½dziemy siï¿½ "cofaï¿½" (krok ujemny)
  Dy = -Dy; // zmieniamy znak skï¿½adowej na dodatki
  TwoDy = -TwoDy; // jak rï¿½wniez podwojonej skï¿½adowej
  }

GLCD_SetPixel(X1,Y1, color); // stawiamy pierwszy krok (zapalamy pierwszy piksel) woher kommt color, evtl mit ï¿½bergeben

if ((Dx != 0) || (Dy != 0)) // sprawdzamy czy linia skï¿½ada siï¿½ z wiï¿½cej niï¿½ jednego punktu ;)
  {
  // sprawdzamy czy skï¿½adowa pionowa jest mniejsza lub rï¿½wna skï¿½adowej poziomej
  if (Dy <= Dx) // jeï¿½li tak, to idziemy "po iksach"
    { 
    TwoDxAccumulatedError = 0; // zerujemy zmiennï¿½ 
    do // ruszamy w drogï¿½
	  {
      CurrentX += Xinc; // do aktualnej pozycji dodajemy krok 
      TwoDxAccumulatedError += TwoDy; // a tu dodajemy podwojonï¿½ skï¿½adowï¿½ pionowï¿½
      if(TwoDxAccumulatedError > Dx)  // jeï¿½li TwoDxAccumulatedError jest wiï¿½kszy od Dx
        {
        CurrentY += Yinc; // zwiï¿½kszamy aktualnï¿½ pozycjï¿½ w pionie
        TwoDxAccumulatedError -= TwoDx; // i odejmujemy TwoDx
        }
       GLCD_SetPixel(CurrentX,CurrentY, color);// stawiamy nastï¿½pny krok (zapalamy piksel)
       }while (CurrentX != X2); // idziemy tak dï¿½ugo, aï¿½ osiï¿½gniemy punkt docelowy
     }
   else // w przeciwnym razie idziemy "po igrekach" 
      {
      TwoDyAccumulatedError = 0; 
      do 
	    {
        CurrentY += Yinc; 
        TwoDyAccumulatedError += TwoDx;
        if(TwoDyAccumulatedError>Dy) 
          {
          CurrentX += Xinc;
          TwoDyAccumulatedError -= TwoDy;
          }
         GLCD_SetPixel(CurrentX,CurrentY, color); 
         }while (CurrentY != Y2);
    }
  }
}
//

